/* 
   manae --- skimple kana MANA Exchanger
   cands.c --- making candidates lists module
   Copyright 1998-2000 IWAMA Naozumi
   This file is written in SJIS.
   ̃t@C SJIS ŋLqĂ܂B
*/

#pragma pack(2)

#include <stdio.h>
#include <System/SysAll.h>
#include <UI/UIAll.h>
#include <System/FeatureMgr.h>

#include "id.h"
#include "manae.h"
#include "myfunc.h"

Int addChar(CharPtr str, Char c);
CharPtr GetNextChar(CharPtr source, Char sep, Char stopC);
//CharPtr searchStr(CharPtr target, CharPtr domain, ULong len,
//		  Char sep, Char stopC);
//CharPtr searchStr2(CharPtr target, CharPtr domain, ULong len,
//		  Char sep, Char stopC);

// in kanjidb.c
DmOpenRef OpenMemoDB(GlobalPtr g);
Err CloseMemoDB(GlobalPtr g);
VoidHand ManaeGetCandRec(GlobalPtr g);
Err ManaeReleaseCandRec(GlobalPtr g);
VoidHand ManaeGetUserCandRec(GlobalPtr g);
Err ManaeReleaseUserCandRec(GlobalPtr g);
VoidHand ManaeGetLearnCandRec(GlobalPtr g);
Err ManaeReleaseLearnCandRec(GlobalPtr g);

Boolean ManaeCandInit(GlobalPtr g);
CharPtr mystrncpy(CharPtr d, const Char* s, Word n);
//Err MyFtrGet(DWord creator, UInt featureNum, DWordPtr valueP);
//Err MyFtrSet(DWord creator, UInt featureNum, DWord newValue);
Boolean ManaeDrawChars(CharPtr str, UInt len, Short x, Short y, GlobalPtr g);

// completion.c
Boolean Kanji2Yomigana(CharPtr yomiP, CharPtr kanjiP, GlobalPtr g);

#ifdef DEBUG
static void ShowLearnDicItem(void *p, SWord x, SWord y)
{
  Char mess[50];
  StrPrintF(mess, "%x:%x:", (Int)p, (*(unsigned char*)p));
  WinDrawChars(mess, MyStrLen(mess), x, y);
  WinDrawChars((char*)p + 1, LineLen((char*)p + 1), x + 80, y);
}
#endif



// Internal Codes functions.
// This internal code system is a simple extention of SJIS.
// Each character have fixed 16 bits length.
// ASCII (and hankaku-kana) characters are expanded 16 bits.
// SJIS zenkaku characters are not changed.
// The terminator code is 0x0000.

// Convert sjis to internal code.
static Int Sjis2Internal(UInt internal[], Char sjis[])
{
  Int i, j;

  for (i = 0, j = 0; sjis[i] != nullChr; i++, j++) {
    if (sjis[i] < 0x00) {
      internal[j] = (((UInt)sjis[i] & 0xff) << 8) + ((UInt)sjis[i + 1] & 0xff);
      i++;
    } else {
      internal[j] = (UInt)sjis[i] & 0xff;
    }
  }
  internal[j] = 0; // instead nullChr
  return(j);
}

/*
// Convert internal to sjis code.
static UInt Internal2Sjis(Char sjis[], Int internal[])
{
  UInt i, j;

  for (i = 0, j = 0; internal[i] != 0; i++, j++) {
    if (internal[i] > 0x8000) {
      sjis[j++] = (Char)((internal[i] & 0xff00) >> 8);
      sjis[j] = (Char)(internal[i] & 0x00ff);
    } else {
      sjis[j] = (Char)(internal[i] & 0x00ff);
    }
  }
  sjis[j] = nullChr;
  return(j);
}
*/

static Int InternalPoint2SjisPoint(UInt internal[], const UInt iP)
{
  Int i, sP;

  for (i = 0, sP = 0; i < iP; i++) {
    if (internal[i] == 0) {
      return(sP);
    }
    sP += (internal[i] > 0x8000) ? 2 : 1;
  }
  return(sP);
}

// 
static Int StrCompareBackward(const CharPtr s1, const CharPtr s2)
{
  //  UInt i1[LEARNITEMSIZE], i2[LEARNITEMSIZE];
  UInt *i1, *i2;
  Int i1P, i2P, ret;

  //  ErrNonFatalDisplayIf(true, "StrCompareBackward");

  i1 = MemPtrNew(LEARNITEMSIZE);
  if (i1 == NULL) {
    return(0);
  }
  i2 = MemPtrNew(LEARNITEMSIZE);
  if (i2 == NULL) {
    MemPtrFree(i1);
    return(0);
  }

  i1[0] = 0;
  i2[0] = 0;

  for (i1P = Sjis2Internal(i1, s1), i2P = Sjis2Internal(i2, s2);
       (i1[i1P] == i2[i2P]) && (i1P >= 0);
       i1P--, i2P--) {
  }

  ret = InternalPoint2SjisPoint(i1, i1P + 1);
  MemPtrFree(i2);
  MemPtrFree(i1);
  return(ret);
}

/*
CharPtr searchStr4(CharPtr target, CharPtr domain, CharPtr startP,
		   ULong len, Char sep, CharPtr *nextStartP)
{
  Int i, j, targetLen, currLen;
  CharPtr s, s2;

  targetLen = StrLen(target);

  for (*nextStartP = s = startP, j = 0; s <= (domain + len);
       s = nextSepCrLf(s, nullChr) + 1) { // skip next cr or linefeed.
    s2 = nextSep(s, '/');
    if ((currLen = (Int)(s2 - s)) < (targetLen)) {
      if (*nextStartP == domain)  *nextStartP = s;
      //      if (currLen < (targetLen - 1)) { // - 1 is for safe.
      if (currLen < (targetLen)) { // for dic-tk
	return(NULL);
      }
    }
    if (currLen == targetLen) {
      if (targetLen == 0) return(s);
      for (i = currLen - 1; i >= 0; i--) {
	if (*(s + i) != *(target + i)) break;
      }
      if (i < 0) {
	if (*nextStartP == domain)  *nextStartP = s;
	return(s);
      }
    }
  }
  return(NULL);
}
*/

// returned:
//	position
//	not found	-1
#define UCSIZE 256
int BM1(unsigned char *pat, int patLen, unsigned char *text, int textLen)
{
  unsigned char *skip;
  unsigned char currC;
  int i, j;

  if (patLen > textLen) {
      return(-1);
  }

  if (patLen == 1) {
    for (i = 0; i < textLen; i++) {
      if (pat[0] == text[i]) {
	return(i);
      }
    }
    return(-1);
  }
  
  // make a skip table.
  skip = MemPtrNew(UCSIZE);
  if (skip == NULL) {
    //    WinDrawChars("BM1: error", 10, 0, 0);
    return(-1);
  }
  
  for (i = 0; i < UCSIZE; i++) {
    skip[i] = patLen;
  }
  for (i = 0; i < patLen - 1; i++) {
    skip[pat[i]] = patLen - i - 1;
  }

  // search.
  for (i = patLen - 1; i < textLen;) {
    for (j = patLen - 1, currC = text[i];
	 (j >= 0) && (pat[j] == text[i]);){
      i--;
      j--;
    }
    if (j < 0) {
      MemPtrFree(skip);
      return(i + 1);
    }
    i += skip[currC] + patLen - 1 - j;
  }
  MemPtrFree(skip);
  return(-1);
}
  

// A boundaryP is a last address of a search domain.
static CharPtr searchStr5(CharPtr targetP, CharPtr domainP, CharPtr boundaryP, Char sep)
{
  Int l;
  int s, ds, t;

  // get target len
  for (l = 0;
       ((*(targetP + l) != nullChr) &&
	(*(targetP + l) != crChr) &&
	(*(targetP + l) != linefeedChr)); l++);

  if (l == 0) {
    return(domainP);
  }
  
  for (s = 0; s <= (ds = (int)(boundaryP - domainP));) {
    t = BM1((unsigned char*)targetP, l,
	    (unsigned char*)(domainP + s), ds - s + 1);
    if (t == -1) {
      return(NULL);
    }
    s += t;
    if (*(domainP + s + l) == sep) {
      if (s == 0) {
	return(domainP);
      } else {
	if ((*(domainP + s - 1) == crChr) ||
	    (*(domainP + s - 1) == linefeedChr)) {
	  return(domainP + s);
	}
      }
    }
    s = s + l;
  }
  return(NULL);
}

/*
Int searchStr6(CharPtr patP, CharPtr textP, Int start,
	       ULong textLen, Char sep, Int *nextStartP)
{
  Int patLen;
  int s, t;

  patLen = MyStrLen(patP);
  if (patLen == 0) return(0);
  for (s = start; s < textLen;) {
    t = BM1((unsigned char*)patP, patLen,
	     (unsigned char*)(textP + s), textLen - s);
    if (t == -1) {
      return(-1);
    }
    s += t;
    if (*(textP + s + patLen) == sep) {
      if (s == 0) {
	*nextStartP = s;
	return(s);
      } else {
	if ((*(textP + s - 1) == crChr) ||
	    (*(textP + s - 1) == linefeedChr)) {
	  *nextStartP = s;
	  return(s);
	}
      }
    }
    s += patLen;
  }
  return(-1);
}
*/

// search a yomigana in J-OS dic.
Int searchStr7(CharPtr patP, CharPtr textP, Int start,
	       ULong textLen, Char sep, Int *nextStartP)
{
  Int patLen, lcLen;
  int s, t;
  CharPtr tmpPatP;

  *nextStartP = start;

  // get a pattern's length.
  patLen = MyStrLen(patP);

  // if start == 0 ...
  if (start == 0) {
    for (s = start; s < patLen; s++) {
      if (patP[s] != textP[s]) break;
    }
    if ((patP[s] == nullChr) && (textP[s] == sep)) {
      // the first item matches.
      return(0);
    }
  }
  
  // get the length of the first candidate (longest yomigana) in the record.
  //  for (lcLen = 0; textP[lcLen] != '/';) {
  for (lcLen = 0; textP[lcLen] != sep;) {
    lcLen += (textP[lcLen] < 0) ? 2 : 1;
  }

  if (patLen > lcLen) return(-1);

  // the first item doesn't match...
  tmpPatP = MemPtrNew(patLen + 3); // 3 for crChr, '/' and nullChr.
  if (tmpPatP == NULL) { 
    //    ErrorPrint("manae:searchStr7: fatal error", 0, 0);
    return(-1);
  }
  tmpPatP[0] = crChr;
  for (s = 0; s < patLen; s++) {
    tmpPatP[s + 1] = patP[s];
  }
  //  tmpPatP[s + 1] = '/';
  tmpPatP[s + 1] = sep;
  tmpPatP[s + 2] = nullChr;

  t = BM1((unsigned char*)tmpPatP, s + 2,
	  (unsigned char*)(textP + start), textLen - start);
  if (t == -1) {
    MemPtrFree(tmpPatP);
    return(-1);
  }
  MemPtrFree(tmpPatP);
  *nextStartP = t + start + 1; // + 1 for crChr
  return(*nextStartP); // return(t + start);
}

Boolean CandsDelKana(CharPtr tmpKana, CharPtr tmpOkuriCP, CharPtr tmpOkuri) 
{
  Int i;
  Char tmp[5];

  if (*tmpOkuriCP != nullChr) {
    *tmpOkuriCP = nullChr;
    return(true);
  }
  
  i = StrLen(tmpKana);
  if (i == 0) return(false);
  tmp[0] = tmpKana[i - 2];
  tmp[1] = tmpKana[i - 1];
  tmp[2] = nullChr;
  tmpKana[i - 2] = nullChr;

  i = StrLen(tmpOkuri);
  tmpOkuri[i] = tmpKana[0];
  tmpOkuri[i + 1] = tmpOkuri[1];
  tmpOkuri[i + 2] = nullChr;
  return(true);
}

CharPtr strncpyplus(CharPtr dist, CharPtr source, Int len, Char sep)
{
  Int i;

  for (i = 0;
       ((source[i] != sep) && (source[i] != nullChr) &&
	(i < len)); 
       i++) {
    dist[i] = source[i];
  }
  for (; i < len; ) {
    dist[i++] = 0x81; // Double Byte Space.
    dist[i++] = 0x40;
  }
  dist[i] = nullChr;
  return(dist);
}

CharPtr strncpyplus2(CharPtr dist, CharPtr source, Int len, Char sep)
{
  Int i;

  for (i = 0;
       ((source[i] != sep) && (source[i] != nullChr) &&
	(source[i] != crChr) &&
	(source[i] != linefeedChr) &&
	(i < len)); 
       i++) {
    dist[i] = source[i];
    if (source[i] < 0) {
      dist[++i] = source[i];
    }
  }
  for (; i < len; ) {
    dist[i++] = nullChr; // Single Byte Space.
  }
  dist[i] = nullChr;
  return(dist);
}

CharPtr CandsSkipCand(CharPtr ptr, Int columnNum)
{
  int i;

  for (i = 0; i < columnNum; i++) {
    if ((ptr = GetNextChar(ptr, '/', nullChr)) == NULL) {
      return(NULL); // no next page
    } else {
      ptr++; // skip '/'
    }
  }
  return(ptr);
}

FormPtr CandsGetCandsForm()
{
  FormPtr frm, frm1;

  FtrGet(CREATOR, FEATURECANDSFRM, (DWordPtr)&frm);
  frm1 = FrmGetActiveForm();
  if (frm != frm1) {
    //    Char tmp[64];

    //    StrPrintF(tmp, "frm:%x, frm1:%x", frm, frm1);
    //    FrmCustomAlert(Alert, "cands.c", "CandsFormHandleEvent()",  tmp);
    FrmSetActiveForm(frm);
    FrmDrawForm(frm);
  }
  return(frm);
}

Boolean CandsSetButton(Char candsButtonStr[CANDSPERPAGE][CANDSBUTTONSTRLEN],
		       Int page, CharPtr candsP, GlobalPtr g)
{
  CharPtr startCandsP, tmpCandP;
  Int i;
  FormPtr frm;
  ControlPtr cp;
  Word idx;

  g->maxPage = page + 1;
  g->maxNumInPage = 0;
  if ((startCandsP = 
       CandsSkipCand(candsP, CANDSPERPAGE * page + 1))
      == NULL) {
    //    FrmCustomAlert(Alert, "cands.c", "CandsSetButton()", 
    //		     "Can't skip cand");
    return(false);
  }

  tmpCandP = startCandsP;
  frm = CandsGetCandsForm();
  idx = FrmGetObjectIndex(frm, ID_CANDS_BUTTON_PREV);
  cp = FrmGetObjectPtr(frm, idx);
  if (page == 0) {
    CtlHideControl(cp);
  } else {
    CtlShowControl(cp);
  }

  for (i = 0; i < CANDSPERPAGE; i++) {
    strncpyplus(candsButtonStr[i], tmpCandP, 8, '/');
    idx = FrmGetObjectIndex(frm, ID_CANDS_BUTTON_0 + i);
    cp = FrmGetObjectPtr(frm, idx);
    cp->text = candsButtonStr[i];
    CtlShowControl(cp);
    idx = FrmGetObjectIndex(frm, ID_CANDS_BUTTON_NEXT);
    cp = FrmGetObjectPtr(frm, idx);
    CtlShowControl(cp);
    g->maxNumInPage = i;

    if (!(tmpCandP = CandsSkipCand(tmpCandP, 1))) {
      g->maxPage = page;
      for (i++; i < CANDSPERPAGE; i++) {
	idx = FrmGetObjectIndex(frm, ID_CANDS_BUTTON_0 + i);
	cp = FrmGetObjectPtr(frm, idx);
	CtlHideControl(cp);
      }
      idx = FrmGetObjectIndex(frm, ID_CANDS_BUTTON_NEXT);
      cp = FrmGetObjectPtr(frm, idx);
      CtlHideControl(cp);
      return(false);
    }
  }
  return(true); 
}

Boolean CandsSetCand(CharPtr distP, CharPtr srcP, DWord page, Int i)
{
  CharPtr tmpP;
  Byte len;

  srcP = CandsSkipCand(srcP + 1, page * CANDSPERPAGE + i);
  tmpP = GetNextChar(srcP, '/', nullChr);
  len  = (tmpP != NULL) ? (Byte)(tmpP - srcP) : (Byte)StrLen(srcP);
  DmWrite(distP, 0, srcP, len);
  DmSet(distP, len, 2, nullChr);

  return(true);
}

// Cands Event Handler
Boolean CandsFormHandleEvent(EventPtr event)
{
  DWord page;
  Boolean handled = false;
  FormPtr frm;
  Char candsButtonStr[CANDSPERPAGE][CANDSBUTTONSTRLEN];
  GlobalPtr g;
  Int candNo;

  FtrGet(CREATOR, FEATUREGLOBAL, (DWordPtr)&g);
  FtrGet(CREATOR, FEATURECANDSPAGE, &page);
  
  if (page == 0x1000) {
    page = 0;
    frm = CandsGetCandsForm();
    FrmDrawForm (frm);    
    CandsSetButton(candsButtonStr, page, g->candsP, g);
    //    FrmSetActiveForm(frm);

    handled = true;
  }

  switch (event->eType) {
  case frmUpdateEvent:
  case frmGotoEvent:
    break;

  case frmLoadEvent:
  case frmOpenEvent:
    frm = CandsGetCandsForm();
    //    FrmSetActiveForm(frm);
    FrmDrawForm (frm);
    break;

  case keyDownEvent:
    if (event->data.keyDown.chr == ('g' - 'a' + 1)) {
      //      FrmReturnToForm (NULL);
      page = CANDSCANCELEDMASK;
      DmSet(g->selectedCandP, 0, 4, 0); // initialise
      event->eType = keyDownEvent;
      event->penDown = true;
      event->screenX = 0;
      event->screenY = 0;
      event->data.keyDown.chr = linefeedChr;
      event->data.keyDown.keyCode = 0;
      event->data.keyDown.modifiers = 0;
      EvtAddEventToQueue(event);
      handled = true;
      break;
    }

    if ((event->data.keyDown.chr == ' ') ||
	(event->data.keyDown.chr == vchrJogDown) ||
	(event->data.keyDown.chr == vchrJogPageDown)) {
      if (page != g->maxPage){
	page++;
	frm = CandsGetCandsForm();
	CandsSetButton(candsButtonStr, page, g->candsP, g);
      }
      handled = true;
      break;
    }
    if ((event->data.keyDown.chr == 'x') ||
	(event->data.keyDown.chr == vchrJogUp) ||
	(event->data.keyDown.chr == vchrJogPageUp)) {
      if (page > 0) {
	page--;
	frm = CandsGetCandsForm();
	CandsSetButton(candsButtonStr, page, g->candsP, g);
	FrmDrawForm(frm);
      }
      handled = true;
      break;
    }
    if ((event->data.keyDown.chr == backspaceChr) ||
	(event->data.keyDown.chr  == ('g' - 'a' + 1))) {
      //      FrmReturnToForm (NULL);
      page = CANDSCANCELEDMASK;
      DmSet(g->selectedCandP, 0, 4, 0); // initialise
      event->eType = keyDownEvent;
      event->penDown = true;
      event->screenX = 0;
      event->screenY = 0;
      event->data.keyDown.chr = linefeedChr;
      event->data.keyDown.keyCode = 0;
      event->data.keyDown.modifiers = 0;
      EvtAddEventToQueue(event);
      handled = true;
      break;
    }

    candNo = -1;
    switch (event->data.keyDown.chr) {
    case '1':
    case 'a':
      candNo = 0;
      break;
    case '2':
    case 's':
      candNo = 1;
      break;
    case '3':
    case 'd':
      candNo = 2;
      break;
    case '4':
    case 'f':
      candNo = 3;
      break;
    case '5':
    case 'g':
      candNo = 4;
      break;
    case '6':
    case 'h':
      candNo = 5;
      break;
    case '7':
    case 'j':
      candNo = 6;
      break;
    case '8':
    case 'k':
      candNo = 7;
      break;
    case '9':
    case 'l':
      candNo = 8;
      break;
      
    default:
      break;
    }
    if (candNo != -1) {
      if (candNo > g->maxNumInPage) {
	candNo = g->maxNumInPage;
      }
      //    FrmReturnToForm(NULL);
      CandsSetCand(g->selectedCandP, g->candsP, page, 
		   candNo);
      
      page = CANDSSELECTEDMASK;
      event->eType = keyDownEvent;
      event->penDown = true;
      event->screenX = 0;
      event->screenY = 0;
      event->data.keyDown.chr = linefeedChr;
      event->data.keyDown.keyCode = 0;
      event->data.keyDown.modifiers = 0;
      EvtAddEventToQueue(event);
    }
    handled = true;
    break;

  case ctlSelectEvent:
    switch (event->data.ctlSelect.controlID) {

    case ID_CANDS_BUTTON_DONE:
      //      FrmReturnToForm (NULL);
      page = CANDSCANCELEDMASK;
      DmSet(g->selectedCandP, 0, 4, 0); // initialise
      event->eType = keyDownEvent;
      event->penDown = true;
      event->screenX = 0;
      event->screenY = 0;
      event->data.keyDown.chr = linefeedChr;
      event->data.keyDown.keyCode = 0;
      event->data.keyDown.modifiers = 0;
      EvtAddEventToQueue(event);
      handled = true;
      break;

    case ID_CANDS_BUTTON_NEXT:
      page++;
      frm = CandsGetCandsForm();
      CandsSetButton(candsButtonStr, page, g->candsP, g);
      handled = true;
      break;

    case ID_CANDS_BUTTON_PREV:
      page--;
      frm = CandsGetCandsForm();
      CandsSetButton(candsButtonStr, page, g->candsP, g);
      FrmDrawForm(frm);
      handled = true;
      break;

    default:
      if ((event->data.ctlSelect.controlID >= ID_CANDS_BUTTON_0) ||
	  (event->data.ctlSelect.controlID <
	   ID_CANDS_BUTTON_0 + CANDSPERPAGE)) {
	//	FrmReturnToForm(NULL);
	CandsSetCand(g->selectedCandP, g->candsP, page, 
		     event->data.ctlSelect.controlID -
		     ID_CANDS_BUTTON_0);

	page = CANDSSELECTEDMASK;
	event->eType = keyDownEvent;
	event->penDown = true;
	event->screenX = 0;
	event->screenY = 0;
	event->data.keyDown.chr = linefeedChr;
	event->data.keyDown.keyCode = 0;
	event->data.keyDown.modifiers = 0;
	EvtAddEventToQueue(event);
	
	handled = true;
	break;
      } else {
	handled = false;
	break;
      }
	
    }
    break;

  case appStopEvent: // It's very IMPORTANT!
    //    FrmReturnToForm (NULL);
    page = CANDSCANCELEDMASK;
    DmSet(g->selectedCandP, 0, 4, 0); // initialise
    event->eType = keyDownEvent;
    event->penDown = true;
    event->screenX = 0;
    event->screenY = 0;
    event->data.keyDown.chr = linefeedChr;
    event->data.keyDown.keyCode = 0;
    event->data.keyDown.modifiers = 0;
    EvtAddEventToQueue(event);
    handled = false;
    break;

  default:
    break;
  }

  FtrSet(CREATOR, FEATURECANDSPAGE, page);
  return (handled);
}

Boolean CandsFormEventLoop(void)
{
  EventType e;
  Boolean done;
  DWord page;

  done = false;
  do {
    EvtGetEvent(&e, evtWaitForever);
    if (! SysHandleEvent (&e))
      done = FrmDispatchEvent (&e);
    FtrGet(CREATOR, FEATURECANDSPAGE, &page);
  } while ((e.eType != appStopEvent) &&
	   (page != CANDSCANCELEDMASK) &&
	   (page != CANDSSELECTEDMASK));
  return(done);
}

Int DeleteAChar(CharPtr str) {
  Int len;

  len = StrLen(str);

    len = (len <= 1) ? 0 : (str[len - 1] < 0x40) ? 1 : 2;

  str[len] = nullChr;
  return(len);
}

Char Hira2Consonant(unsigned char *hira)
{
  if (hira[0] != 0x82) return(nullChr);

  switch (hira[1]) {
  case 0x9f:
  case 0xa1:
  case 0xa3:
  case 0xa5:
  case 0xa7:
  case 0xe1:
  case 0xe3:
  case 0xe5:
  case 0xec:
    return('x');
   case 0xa0:
    return('a');
  case 0xa2:
    return('i');
  case 0xa4:
    return('u');
  case 0xa6:
    return('e');
  case 0xa8:
    return('o');
  case 0xa9:
  case 0xab:
  case 0xad:
  case 0xaf:
  case 0xb1:
    return('k');
  case 0xaa:
  case 0xac:
  case 0xae:
  case 0xb0:
  case 0xb2:
    return('g');
  case 0xb3:
  case 0xb5:
  case 0xb7:
  case 0xb9:
  case 0xbb:
    return('s');
  case 0xb6:
    return('j');
  case 0xb4:
  case 0xb8:
  case 0xba:
  case 0xbc:
    return('z');
  case 0xbd:
  case 0xbf:
  case 0xc2:
  case 0xc4:
  case 0xc6:
    return('t');
  case 0xbe:
  case 0xc0:
  case 0xc3:
  case 0xc5:
  case 0xc7:
    return('d');
  case 0xc8:
  case 0xc9:
  case 0xca:
  case 0xcb:
  case 0xcc:
  case 0xf1:
    return('n');
  case 0xcd:
  case 0xd0:
  case 0xd3:
  case 0xd6:
  case 0xd9:
    return('h');
  case 0xce:
  case 0xd1:
  case 0xd4:
  case 0xd7:
  case 0xda:
    return('b');
  case 0xcf:
  case 0xd2:
  case 0xd5:
  case 0xd8:
  case 0xdb:
    return('p');
  case 0xdc:
  case 0xdd:
  case 0xde:
  case 0xdf:
  case 0xe0:
    return('m');
  case 0xe2:
  case 0xe4:
  case 0xe6:
    return('y');
  case 0xe7:
  case 0xe8:
  case 0xe9:
  case 0xea:
  case 0xeb:
    return('r');
  case 0xed:
  case 0xee:
  case 0xef:
  case 0xf0:
    return('w');
  default:
    return(nullChr);
  }
  return(nullChr);
}

// This function shows the 1st candidate before normal displaying.
inline static Boolean CandsShow1stCand(CharPtr candP, CharPtr okuriP,
				       GlobalPtr g)
{
  //  Char tmpCand[KANALEN];
  Char *tmpCand;
  RectangleType r;

  tmpCand = MemPtrNew(KANALEN);
  if (tmpCand == NULL) {
    return(false);
  }

  tmpCand[0] = nullChr;

  StrCopy(tmpCand, KOHOCHR);
  strncpyplus2(tmpCand + KOHOCHRLEN, candP, KANALEN - 4, '/');
  MyStrCat(tmpCand, okuriP);
  r.topLeft.x = g->kanjiStartX;
  r.topLeft.y = g->kanjiStartY;
  r.extent.x = ((StrLen(g->formerDrawP) + 1) / 2) * 9;
  r.extent.y = 10;
  WinEraseRectangle (&r, 0);
  ManaeDrawChars(tmpCand, StrLen(tmpCand), 
		 g->insPtX, g->insPtY, g);
  MemPtrFree(tmpCand);
  return(g->printed = true);
}

Int CandsShortenKana(CharPtr kana, CharPtr okuriC, CharPtr okuri)
{
  Int len, cc;
  //  Char tmpStr[KANALEN * 2];
  Char *tmpStr;

  len = StrLen(kana);

  if (*okuriC != nullChr) {
    *okuriC = nullChr;
    return(len);
  }

  if (len <= 2) {
    return(0);
  }

  cc = (len <= 2) ? 0 : (kana[len - 2] < 0x00) ? 2 : 1; 
  // cc is the deleting characters' length.

  tmpStr = MemPtrNew(KANALEN * 2);
  if (tmpStr == NULL) {
    return(-1);
  }
  tmpStr[0] = kana[len - cc];
  tmpStr[1] = kana[len - cc + 1]; // if (cc == 1) tmpStr[1] = nullChr;!!!
  tmpStr[2] = nullChr;
  *okuriC = Hira2Consonant(tmpStr);
  kana[len - cc] = nullChr;
  MyStrCat(tmpStr, okuri);
  StrCopy(okuri, tmpStr);
  MemPtrFree(tmpStr);
  return(len - cc);
}

Int DivideKana(CharPtr kanaP, CharPtr okuriC, CharPtr okuriP, Int len)
{
  Char tmpStr[KANALEN];
  Int okuriF, i, j = 0;

  okuriF = len & 0x01;
  len = len - okuriF;
  StrCopy(tmpStr, okuriP);
  for (i = len, j = 0; kanaP[i] != nullChr; i++, j++) {
    okuriP[j] = kanaP[i];
  }
  okuriP[j] = nullChr;
  MyStrCat(okuriP, tmpStr);
  if (okuriF == 1) {
    *okuriC = Hira2Consonant(&kanaP[len]);
    kanaP[len] = *okuriC;
    kanaP[len + 1] = nullChr;
  } else {
    kanaP[len] = nullChr;
  }
  return(len);
}

Boolean CandsDicCandInit(CharPtr kana, Char okuriC, CharPtr okuri,
			  GlobalPtr g)
{
  CharPtr currCand;
  Char tmpC[KANALEN + 4];
  Int currCandOffset;

  g->candsOffset = 0;

  if (g->candP == NULL) return(false); // This is important.

  StrCopy(tmpC, kana + 2);

  if (okuriC != nullChr) {
    addChar(tmpC, okuriC);
  }

  if ((currCandOffset = searchStr7(tmpC, g->candP, g->nextStart,
				   g->candRecLen, '/', &(g->nextStart)))
      == -1) {
    return(false);
  }
  
  if ((currCand = GetNextChar(g->candP + currCandOffset, '/', crChr))
      == NULL) {
    return(false);
  }

  g->candsOffset = currCand - g->candP; // and currCandOffset = 0
  if (g->printed == false) {
    CandsShow1stCand(g->candP + g->candsOffset + 1, okuri, g);
    g->printed = true;
  }
  return(true);
}


// Functions for learning.
inline static VoidPtr searchLearnNext(VoidPtr currP, VoidPtr boundaryP)
{
  VoidPtr nextP;
  unsigned char yomiLen, kanjiLen;

  yomiLen = (*(unsigned char*)currP & (unsigned char)0xf0) >> 4;
  kanjiLen = (*(unsigned char*)currP & (unsigned char)0x0f);

  if ((yomiLen + kanjiLen) == 0) { // the end of dic.
    return(NULL);
  }

  nextP = (currP + yomiLen + kanjiLen + 3);
  if ((yomiLen != 0x0f) && (kanjiLen != 0x0f)) {
    if (nextP > boundaryP) { // the end of dic.
      return(NULL);
    }
#ifdef DEBUG
    ShowLearnDicItem(nextP, 0, 150);
#endif
    return(nextP); // 3 for header, '/', linefeedChr
  }
  for (;nextP <= boundaryP; nextP++) {
    if ((*(unsigned char*)nextP != linefeedChr) &&
	(*(unsigned char*)(nextP - 1) == linefeedChr)) {
      if (*(unsigned char*)nextP == 0) { // the end of dic.
	return(NULL);
      }
#ifdef DEBUG
      ShowLearnDicItem(nextP, 0, 150);
#endif
      return(nextP);
    }
  }
  return(NULL);
}

static CharPtr searchLearnYomiKanji(CharPtr yomiP, CharPtr kanjiP,
				    VoidPtr learnP,
				    VoidPtr boundaryP)
{
  CharPtr s;
  unsigned char yomiLen, kanjiLen, h;
  Int i;

  yomiLen = (unsigned char)LineLen(yomiP);
  kanjiLen = (unsigned char)LineLen(kanjiP);

  h = ((yomiLen > (unsigned char)0x0f) ?
	((unsigned char)0xf0) : (yomiLen << 4)) |
    ((kanjiLen > (unsigned char)0x0f) ? (unsigned char)0x0f : kanjiLen);
  s = learnP;

  // correct start point for search.
  for (;((*(s - 1) != linefeedChr) || 
	 (*s == linefeedChr))
	 ; s++){
  }

  for (; (VoidPtr)s <= boundaryP;) {
    if (*(unsigned char*)s == h) {
      for (i = 0;
	   ((i < yomiLen) &&
	    (*(s + 1 + i) == *(yomiP + i)))
	     ; i++);
      if (i == yomiLen) {
	for (i = 0;
	     ((i < kanjiLen) &&
	      (*(s + 1 + yomiLen + 1 + i) == *(kanjiP + i)))
	       ; i++);
	if (i == kanjiLen) {
	  return(s);
	}
      }
    }

    /*
    s = s + ((*(unsigned char*)s & (unsigned char)0xf0) >> 4) +
      (*(unsigned char*)s & (unsigned char)0x0f) + 1;
    for (;(*s != linefeedChr) && ((VoidPtr)s <= boundaryP); s++);
    s++;
    */
    s = searchLearnNext(s, boundaryP);
    if (s == NULL) {
      return(NULL);
    }
  }
  return(NULL);
}

static CharPtr searchLearnYomi(CharPtr yomiP, VoidPtr learnP,
			       VoidPtr boundaryP)
{
  CharPtr s;
  unsigned char yomiLen;
  Int i;

  yomiLen = (unsigned char)LineLen(yomiP);

  s = learnP;

  //  WinDrawChars(s, 30, 0, 140);
  // correct start point for search.
  // if the dic is well formed, s must not reach the boundary.
  for (;((*(s - 1) != linefeedChr) || 
	 (*s == linefeedChr))
	 ; s++){
    // do nothing.
  }
  //  WinDrawChars(s, 30, 0, 150);

  for (; (VoidPtr)s <= boundaryP;) {
    if (((*(unsigned char*)s & (unsigned char)0xf0) >> 4) == 
	((yomiLen > (unsigned char)0x0f) ? (unsigned char)0x0f : yomiLen)) {
      for (i = 0;
	   ((i < yomiLen) &&
	    (*(s + 1 + i) == *(yomiP + i)))
	     ; i++);
      if ((i == yomiLen) && (*(s + 1 + i) == '/')) {
	return(s);
      }
    }
    /*
    s = s + ((*(unsigned char*)s & (unsigned char)0xf0) >> 4) +
      (*(unsigned char*)s & (unsigned char)0x0f) + 1; // + 1 means '/'
    // skip till linefeed chr.
    for (;(*s != linefeedChr) && ((VoidPtr)s <= boundaryP); s++);
    s++;
    */
    s = searchLearnNext(s, boundaryP);
    if (s == NULL) {
      return(NULL);
    }
  }
  return(NULL);
}


// (zenpo-icchi) search a yomigana in learning dic.
// returned:
//	matched item pointer.
CharPtr searchLearnYomiCompl(CharPtr yomiP, VoidPtr learnP,
			     VoidPtr boundaryP)
{
  CharPtr s;
  unsigned char yomiLen;
  Int i;

  yomiLen = (unsigned char)LineLen(yomiP);
  // WinDrawChars(learnP, 30, 0, 100);

  s = learnP;

  // correct start point for search.
  // if the dic is well formed, s must not reach the boundary.
  for (;((*(s - 1) != linefeedChr) || 
	 (*s == linefeedChr)) &&
	 ((VoidPtr)s <= boundaryP) 
	 ; s++){
    // do nothing.
  }

  if ((VoidPtr)s > boundaryP) {
    //    WinDrawChars("The learning dic is invalid.", MyStrLen("The learning dic is invalid."), 0, 0);
    return(NULL);
  }

  for (; (VoidPtr)s <= boundaryP;) {
    if (((*(unsigned char*)s & (unsigned char)0xf0) >> 4) >= 
	((yomiLen > (unsigned char)0x0f) ? (unsigned char)0x0f : yomiLen)) {
      for (i = 0;
	   ((i < yomiLen) &&
	    (*(s + 1 + i) == *(yomiP + i)))
	     ; i++);
      if (i == yomiLen) {
	return(s);
      }
    }

    s = searchLearnNext(s, boundaryP);
    if (s == NULL) {
      return(NULL);
    }
  }
  return(NULL);
}

ULong LearnWriteVersion(GlobalPtr g)
{
  Int i, j;
  unsigned char uc;

  // writing version number.
  i = MyStrLen(VERSIONSTR2);
  j = (i - 10 - 1) > 0x0f ? 0x0f : (i - 10 - 1);
  // means "΁[/ "

  uc = 0xa0 + (unsigned char)j;

  DmWrite(g->learnDicP,
	  LEARNDICMAXSIZE - i - 2, VERSIONSTR2, i);
  DmSet(g->learnDicP, LEARNDICMAXSIZE - 1, 1, nullChr);
  DmSet(g->learnDicP, LEARNDICMAXSIZE - 2, 1, linefeedChr);
  DmSet(g->learnDicP, LEARNDICMAXSIZE - i - 3, 1, uc);
  DmSet(g->learnDicP, LEARNDICMAXSIZE - i - 4, 1, linefeedChr);
  
  //  WinDrawChars(g->learnDicP + LEARNDICMAXSIZE - i - 5, i + 5, 0, 0);
  g->learnDicStartPoint = LEARNDICMAXSIZE - i - 3;
  return(g->learnDicStartPoint);
}

Boolean LearnCleanDic(GlobalPtr g)
{
  ULong offset, l;
  //  unsigned char uc;
  WinHandle wH;

  if (ManaeGetLearnCandRec(g) == NULL) {
    //    ErrorPrint("manae: Learning dic is broken???", 0, 0);
    return(false);
  }

  wH = MyDrawCharSave("manae cleaning learning dic.", 28, 0, 0);

  l = LearnWriteVersion(g);
  l--; // l points linefeedChr
  
  // set a start point of copying.
  offset = LEARNDICMAXSIZE - LEARNDELETESIZE;
  for (;*(g->learnDicP + offset) != linefeedChr; offset--);
  // offset point a linefeedChr.
  
  for (; offset >= LEARNDICBODYSTART; offset--) {
    if ((*(g->learnDicP + offset) == linefeedChr) &&
	(*(g->learnDicP + offset - 1) != linefeedChr) &&
	(*(g->learnDicP + offset - 2) == linefeedChr)) {
      offset -= 2;
    }

    if (!((*(g->learnDicP + offset) == linefeedChr) &&
	  (*(g->learnDicP + offset + 1) == linefeedChr))) {
      DmSet(g->learnDicP, l--, 1, *(Byte *)(g->learnDicP + offset));
    }
  }
  // set linefeedChrs as blanks.
  DmSet(g->learnDicP, 0, l + 1, linefeedChr); // l is not length, pointer.
  for (; *(g->learnDicP + l) == linefeedChr; l++); 
  g->learnDicStartPoint = l;
  //  WinDrawChars(g->learnDicP + g->learnDicStartPoint, 30, 0, 20);
  //  WinDrawChars(g->learnDicP + LEARNDICMAXSIZE - 50, 34, 0, 30);
  ManaeReleaseLearnCandRec(g);
  if (wH != NULL) {
    MyRestore(wH, MyStrLen("manae cleaning learning dic."), 0, 0);
  }
  return(true);
}

Boolean LearnWriteCand(CharPtr convertedP,
		       CharPtr kanaP,
		       Char okuriC, CharPtr okuriP,
		       GlobalPtr g)
{
  CharPtr itemP, tmpConvP;
  Int iI, iIInit, cI, i;
  CharPtr oldP;
  unsigned char ih, yomiLen, kanjiLen;
  Boolean learnDicGottenF;
#ifdef DEBUG
  Char mess[20];
#endif

  /*
  if (g->complFlag == 1) {
    g->complFlag = 0;
    return(false);
  }
  */
  
  if (convertedP[0] == nullChr) {
    return(false);
  }

  if ((MyStrLen(kanaP)+ MyStrLen(convertedP) + 1) > LEARNITEMSIZE) {
    return(false);
  }

  if (g->learnDicStartPoint < LEARNDICREDZONE) {
    // Buffer is in red zonel!
    LearnCleanDic(g);
  }

  if (g->learnDicP == NULL) {
    ManaeGetLearnCandRec(g);
    learnDicGottenF = false;
  } else {
    learnDicGottenF = true;
  }

  if (g->learnDicStartPoint < LEARNDICBODYSTART) {
    // Buffer is full!
    //    ErrorPrint("manae: learning dic is broken.", 0, 0);
    //    ErrorPrint("Please delete manae & manaeDB", 0, 10);
    return(false);
  }

#ifdef DEBUG
  ShowLearnDicItem(g->learnDicP + g->learnDicStartPoint, 0, 110);
#endif

  itemP = MemPtrNew(LEARNITEMSIZE);
  if (itemP == NULL) {
    // ErrorPrint("manae:LearnWriteCand:fatal error", 0, 0);
    if (learnDicGottenF == false) {
      ManaeReleaseLearnCandRec(g);
    }

    return(false);
  }

  itemP[0] = nullChr;

  tmpConvP = MemPtrNew(LEARNITEMSIZE);
  if (tmpConvP == NULL) {
    //    ErrorPrint("manae:LearnWriteCand:fatal error", 0, 0);
    MemPtrFree(itemP);
    if (learnDicGottenF == false) {
      ManaeReleaseLearnCandRec(g);
    }
    return(false);
  }
  tmpConvP[0] = nullChr;

  if (g->complFlag == 1) {
    // A kanji selected in completion mode.
    g->complFlag = 0;
    //    *itemP = *kanaP;
    //    *(itemP + 1) = *(kanaP + 1);
    
    //    if (Kanji2Yomigana(itemP + 2, convertedP, g) == false) {
    if (Kanji2Yomigana(itemP, convertedP, g) == false) {
      if (learnDicGottenF == false) {
	ManaeReleaseLearnCandRec(g);
      }
      return(false);
    }
    yomiLen = (unsigned char)MyStrLen(itemP);
    //    WinDrawChars(itemP, yomiLen, 80, 00);

    ih = (yomiLen > (unsigned char)0x0f) ?
      (unsigned char)0xf0 : (yomiLen << 4); 
    MyStrCat(itemP, "/");
    iI = MyStrCat(itemP, convertedP);
    kanjiLen = (unsigned char)MyStrLen(convertedP);
    ih = ih | ((kanjiLen > (unsigned char)0x0f) ?
	       (unsigned char)0x0f : kanjiLen); 
  }
  else if (g->nonSkkMode == true) {
    // non SKK Mode.
    yomiLen = (unsigned char)MyStrLen(kanaP);
    ih = (yomiLen > (unsigned char)0x0f) ?
      (unsigned char)0xf0 : (yomiLen << 4); 
    StrCopy(itemP, kanaP);
    //    ErrorPrint(itemP, 0, 0);
    if (*(g->okuriP) != nullChr) {
      StrCat(itemP, (g->okuriP));
    }
    //    ErrorPrint(itemP, 0, 10);
    MyStrCat(itemP, "/");
    iI = MyStrCat(itemP, convertedP);
    kanjiLen = (unsigned char)MyStrLen(convertedP);
    ih = ih | ((kanjiLen > (unsigned char)0x0f) ?
      (unsigned char)0x0f : kanjiLen); 
  } else {
    // SKK Mode.
    StrCopy(tmpConvP, convertedP);
    StrCopy(itemP, kanaP);
    if (okuriP != NULL) {
      if (okuriP[0] != nullChr) {
	MyStrCat(itemP, okuriP);
      }
    }
    iIInit = MyStrLen(itemP);
    cI = MyStrLen(tmpConvP);
    iI = StrCompareBackward(itemP, tmpConvP);
    cI = cI - (iIInit - iI);

    // if specified okurigana, add okurigana char.
    if (okuriC != nullChr) {
      itemP[iI++] = okuriC;
    }
    yomiLen = (unsigned char)iI;
    ih = (yomiLen > (unsigned char)0x0f) ?
      (unsigned char)0xf0 : (yomiLen << 4); 
    itemP[iI++] = '/';
    itemP[iI] = nullChr;
    tmpConvP[cI] = nullChr;
    kanjiLen = (unsigned char)cI;
    ih = ih | ((kanjiLen > (unsigned char)0x0f) ?
	       (unsigned char) 0x0f : kanjiLen); 
    iI = MyStrCat(itemP, tmpConvP);
  }

  for (i = 0; i < yomiLen; i++) {
    tmpConvP[i] = itemP[i];
  }
  tmpConvP[i] = nullChr;

#ifdef DEBUG
    WinDrawChars("XXXXXXXXXXXXXXXXX", 10, 0, 120);
#endif

  if ((oldP =
       searchLearnYomiKanji(tmpConvP, itemP + yomiLen + 1,
			    g->learnDicP + g->learnDicStartPoint, 
			    g->learnDicP + g->learnDicLen)) != NULL) {
    // delete a found item.
    Int len;

#ifdef DEBUG
    ShowLearnDicItem(oldP, 0, 120);
#endif

    for (len = 1;
	 (*(oldP + len) != linefeedChr) && (*(oldP + len) != nullChr);) {
      len += (*(oldP + len) < 0x00) ? 2 : 1;
    }
    DmSet(g->learnDicP, oldP - g->learnDicP + 1, len, linefeedChr);
#ifdef DEBUG
    ErrorPrint("XXXXXXXXXXXXXXXXXXXXXXXXXX", 0, 140);
    ShowLearnDicItem(oldP, 0, 140);
    ErrorPrint("XXXXXXXXXXXXXXXXXXXXXXXXXX", 0, 150);
    ShowLearnDicItem(oldP + len + 1, 0, 150);
#endif
  }

  // insert new item
  itemP[iI++] = linefeedChr;
  itemP[iI] = nullChr;
  g->learnDicStartPoint -= (iI + 1);
  DmSet(g->learnDicP, g->learnDicStartPoint, 1, (Byte)ih);
  DmWrite(g->learnDicP, g->learnDicStartPoint + 1, itemP, iI);
  DmSet(g->learnDicP, g->learnDicStartPoint - 1, 1, (Byte)linefeedChr);
  //  ManaeReleaseLearnCandRec(g);
#ifdef DEBUG
  ShowLearnDicItem(g->learnDicP + g->learnDicStartPoint, 0, 130);
#endif

  MemPtrFree(tmpConvP);
  MemPtrFree(itemP);

  if (learnDicGottenF == false) {
    ManaeReleaseLearnCandRec(g);
  }
  return(true);
}

static Boolean CandsLearnCandNext(CharPtr kana, Char okuriC, CharPtr okuri,
				  CharPtr startP, GlobalPtr g)
{
  CharPtr currCand;
  Char tmpC[KANALEN + 4];

  //  WinDrawChars(startP, 30, 0, 110);
  g->learnCandsOffset = 0;

  if (g->learnDicH == NULL) return(false); // This is important.

  StrCopy(tmpC, kana);
  if (okuriC != nullChr) {
    addChar(tmpC, okuriC);
  }

  //  if ((currCand = searchStr3(tmpC, startP, g->learnDicP + g->learnDicLen, '/'))
  //      == NULL) {
  //  if ((currCand = searchStr5(tmpC, startP, g->learnDicP + g->learnDicLen, '/'))
  //      == NULL) {
  if ((currCand = searchLearnYomi(tmpC, startP,
				  g->learnDicP + g->learnDicLen))
      == NULL) {
    return(false);
  }

  if ((currCand = GetNextChar(currCand + 1, '/', linefeedChr)) == NULL) {
    return(false);
  }
  g->learnCandsOffset = currCand - g->learnDicP; // and currCandOffset = 0
  return(true);
}

Boolean CandsLearnCandInit(CharPtr kana, Char okuriC, CharPtr okuri,
			   GlobalPtr g)
{
  if (CandsLearnCandNext(kana, okuriC, okuri,
			 g->learnDicP + g->learnDicStartPoint, g)
      == false) {
    return(false);
  }
  if (g->printed == false) {
    CandsShow1stCand(g->learnDicP + g->learnCandsOffset + 1, okuri, g);
    g->printed = true;
  }
    return(true);
}

static Boolean CandsUserCandNext(CharPtr kana, Char okuriC, CharPtr okuri,
			  CharPtr startP, GlobalPtr g)
{
  CharPtr currCand;
  Char tmpC[KANALEN + 4];
  
  g->userCandsOffset = 0;

  if (g->userDicH == NULL) return(false); // This is important.

  StrCopy(tmpC, kana);
  if (okuriC != nullChr) {
    addChar(tmpC, okuriC);
  }

  //  if ((currCand = searchStr3(tmpC, startP, g->userDicP + g->userDicLen, '/'))
  //      == NULL) {

  if ((currCand = searchStr5(tmpC, startP, g->userDicP + g->userDicLen, '/'))
      == NULL) {
  return(false);
  }

  if ((currCand = GetNextChar(currCand, '/', linefeedChr)) == NULL) {
    return(false);
  }
  g->userCandsOffset = currCand - g->userDicP; // and currCandOffset = 0
  return(true);
}

Boolean CandsUserCandInit(CharPtr kana, Char okuriC, CharPtr okuri,
			  GlobalPtr g)
{
  if (CandsUserCandNext(kana, okuriC, okuri, g->userDicP, g) == false) {
    return(false);
  }
  if (g->printed == false) {
    CandsShow1stCand(g->userDicP + g->userCandsOffset + 1, okuri, g);
    g->printed = true;
  }
  return(true);
}

Boolean CandsCandInit(CharPtr kana, Char okuriC, CharPtr okuri,
		      GlobalPtr g)
{
  g->candsOffset = 0 ;

  g->currDicType = 
    (
     (LEARNDIC *
      ((CandsLearnCandInit(kana, okuriC, okuri, g)
	== true) ? 1 : 0)) |
     (USERDIC * 
      ((CandsUserCandInit(kana, okuriC, okuri, g)
	== true) ? 1 : 0)) |
     (JOSDIC *
      ((CandsDicCandInit(kana, okuriC, okuri, g)
	== true) ? 1 : 0))
     );
  
  g->dicType = g->dicType | g->currDicType;
  g->numOfCand = g->dicType;

  return( (g->dicType) ? true : false);
}

ULong CandsWriteCandsList(CharPtr dist, ULongPtr distOffset, 
			  CharPtr srcBase, Int srcOffset,
			  CharPtr kana, CharPtr okuri)
{
  ULong currDistOffset;
  CharPtr currSrcP;
  Int i, okuriLen;
  currDistOffset = *distOffset;
  currSrcP = srcBase + srcOffset;

  okuriLen = StrLen(okuri);
  
  for (i = 0; ((currSrcP[i] != crChr) && (currSrcP[i] != linefeedChr) &&
	       (currSrcP[i] != nullChr)); i++) {
    if (currSrcP[i] < 0x00) { 
      // 2 Byte Char
      DmWrite(dist, currDistOffset, &currSrcP[i], 2);
      i++;
      currDistOffset += 2;
    } else {
      // 1 Byte Char
      DmSet(dist, currDistOffset++, 1, currSrcP[i]);
    }
    if ((currSrcP[i + 1] == '/') ||
	(currSrcP[i + 1] == linefeedChr) ||
	(currSrcP[i + 1] == crChr) ||
	(currSrcP[i + 1] == nullChr)) {
      DmWrite(dist, currDistOffset, okuri, okuriLen);
      currDistOffset += okuriLen;
    }
  }

  DmSet(dist, currDistOffset, 2, nullChr);
  *distOffset = currDistOffset;
  return(*distOffset);
}
  
Boolean CandsMakeCandsList2(CharPtr candsP, ULongPtr offset,
			    CharPtr kana, Char okuriC,
			    CharPtr okuri,
			    GlobalPtr g)
{
  ULong userDicOffset;
  Boolean ret;

  userDicOffset = 0;
  ret = false;

  if (!CandsCandInit(kana, okuriC, okuri, g)) return(false);
  if (g->currDicType & LEARNDIC) {
    CharPtr nextP;
    do {
      CandsWriteCandsList(g->candsP, offset, 
			  g->learnDicP, g->learnCandsOffset,
			  kana, okuri);
      for (nextP = g->learnDicP + g->learnCandsOffset;
	   *nextP != linefeedChr; nextP++);
    } while (CandsLearnCandNext(kana, okuriC, okuri,
				nextP, g));
    ret = true;
  }

  if (g->currDicType & USERDIC) {
    do {
      CandsWriteCandsList(g->candsP, offset, 
			  g->userDicP, g->userCandsOffset,
			  kana, okuri);
    } while (CandsUserCandNext(kana, okuriC, okuri,
			       g->userDicP + g->userCandsOffset, g));
    ret = true;
  }

  if (g->currDicType & JOSDIC) {
    CandsWriteCandsList(g->candsP, offset, 
			g->candP, g->candsOffset,
			kana, okuri);
    ret = true;
  }  
  return(ret);
}


Boolean CandsMakeCandsList(CharPtr kana, Char okuriC, CharPtr okuri, 
			  GlobalPtr g)
{
  Int counter, i, j;
  //  Char tmpKana[KANALEN * 2], tmpOkuri[KANALEN];
  Char *tmpKana, *tmpOkuri;
  Char tmpOkuriC;
  ULong offset;

  offset = 0;
  g->dicType = 0;
  g->currCandOffset = 0;

  // dic. rec. must have been already opened
  if (g->candP == NULL) {
    return(false);
  }

  tmpKana = MemPtrNew(KANALEN * 2);
  if (tmpKana == NULL) {
    return(false);
  }
  tmpKana[0] = nullChr;

  tmpOkuri = MemPtrNew(KANALEN);
  if (tmpOkuri == NULL) {
    MemPtrFree(tmpKana);
    return(false);
  }
  tmpOkuri[0] = nullChr;

  StrCopy(tmpKana, kana);
  StrCopy(tmpOkuri, okuri);
  tmpOkuriC = okuriC;
  counter = 0;
  //  g->nextStartP = g->candP; // set a start point of search.
  g->nextStart = 0;

  for (i = 0, j = 0; j < CONVDEPTH; i++) {
    j = (CandsMakeCandsList2(g->candsP, &offset,
			tmpKana, tmpOkuriC, tmpOkuri, g)) ? j + 1 : j;
    if (offset > CANDSMAXSIZE) {
      MemPtrFree(tmpOkuri);
      MemPtrFree(tmpKana);
      return(true);
    }
    if (CandsShortenKana(tmpKana, &tmpOkuriC, tmpOkuri) == 0) {
      MemPtrFree(tmpOkuri);
      MemPtrFree(tmpKana);
      return(true); // tmpKana is empty.
    }
  }
  MemPtrFree(tmpOkuri);
  MemPtrFree(tmpKana);
  return(true);
}
