/* 
   manae --- skimple kana MANA Exchanger
   kanjidb.c --- manae's kanji database handling module
   Copyright 1998-2000 IWAMA Naozumi
   This file is written in SJIS.
   ̃t@C SJIS ŋLqĂ܂B
*/

#pragma pack(2)

#include <stdio.h>
#include <System/SysAll.h>
#include <UI/UIAll.h>
#include <System/FeatureMgr.h>
#include <System/DataMgr.h>

#include "id.h"
#include "manae.h"
#include "myfunc.h"

void InsertToMainField2(CharPtr s, GlobalPtr g);
Boolean KanaeConvert(CharPtr out, Char c, GlobalPtr g);
Boolean ManaeSetKanaMode(GlobalPtr g);
Boolean isupper(Char c);
CharPtr mystrncpy(CharPtr d, const Char* s, Word n);

// This function works well in ASCII and SJIS.
Boolean strMember(CharPtr domain, CharPtr target)
{
  Int i;
  
  for (i = 0; target[i] != nullChr; i++) {
    if (domain[i] != target[i]) {
      return(false);
    }
  }
  return(true);
}

UInt MyCategoryFind(DmOpenRef db, CharPtr name)
// invalid cat. name causes error in PalmOS 1.0
{
  Word i;
  Char tmp[dmCategoryLength];
  
  for (i = 0; i < dmRecNumCategories; i++) {
    CategoryGetName(db, i, tmp);
    if (StrCompare(name, tmp) == 0) {
      return i;
    }
  }
  return dmAllCategories; // for all categoris
}

DmOpenRef OpenMemoDB(GlobalPtr g)
{
#ifdef LEARNMEMO
  g->memoDB = 
    DmOpenDatabaseByTypeCreator(memoDBType, sysFileCMemo, dmModeReadWrite);
#endif

#ifndef LEARNMEMO
  g->memoDB = 
    DmOpenDatabaseByTypeCreator(memoDBType, sysFileCMemo, dmModeReadOnly);
#endif
  if (g->memoDB == NULL) {
  }
  return(g->memoDB);
}

Err CloseMemoDB(GlobalPtr g)
{
  Err ret;
  if (g->memoDB != NULL) {

    ret = DmCloseDatabase(g->memoDB);
    g->memoDB = NULL;
    return(ret);
  }
  return(0);
}

VoidHand ManaeGetUserCandRec(GlobalPtr g)
{
  Word josCatIndex;
  UInt josIndex;

  g->userDicH = NULL;

  if (OpenMemoDB(g) == NULL) return(NULL);
  josCatIndex = MyCategoryFind(g->memoDB, "J-OS");
  if ((josCatIndex == dmAllCategories) ||
      (josCatIndex == dmUnfiledCategory)) {
    josCatIndex = MyCategoryFind(g->memoDB, "JOS");
    if ((josCatIndex == dmAllCategories) ||
	(josCatIndex == dmUnfiledCategory)) {
      return NULL; // category is not found.
    }
  }

  // Get Memo Handle
  
  josIndex = 0; // This is VERY important!!!
  DmSeekRecordInCategory(g->memoDB, &josIndex, 0, dmSeekForward, josCatIndex);
  if (DmGetLastErr()) {
    return NULL;
  }

  // Get the J-OS category memo record handle.
  g->userDicH = DmQueryRecord(g->memoDB, josIndex);
  
  if (g->userDicH == NULL) {
    //    FrmCustomAlert(Alert, "kanjidb.c", "ManaeGetUserCandRec()", "Bad Record");
    return NULL;
  }
  g->userDicP = MemHandleLock(g->userDicH);
  g->userDicLen = MemHandleSize(g->userDicH);

  return(g->userDicH);
}

Err ManaeReleaseUserCandRec(GlobalPtr g)
{
  if (g->userDicH) {
    MemHandleUnlock(g->userDicH);
    //    DmReleaseRecord(g->userDicH); // no need when useing DmQueryRecord
    g->userDicH = NULL;
  }
  return(CloseMemoDB(g));
}

#ifndef LEARNMEMO
VoidHand ManaeGetLearnCandRec(GlobalPtr g)
{

  g->learnDicH = NULL;
  g->learnDicI = 0;

  if (g->manaeDB == NULL) {
    return(NULL);
  }

  // Get the manaeL category memo record handle.
  g->learnDicH = DmGetRecord(g->manaeDB, MANAELEARNDICINDEX);
  if (g->learnDicH == NULL) {
    //    FrmCustomAlert(Alert, "kanjidb.c", "ManaeGetLearnCandRec()", "Bad Record");
    g->learnDicP = NULL;
    g->learnDicLen = 0;
    return NULL;
  }
  
  g->learnDicI = MANAELEARNDICINDEX;
  g->learnDicP = MemHandleLock(g->learnDicH);
  g->learnDicLen = MemHandleSize(g->learnDicH);

  if (g->learnDicStartPoint == 0) {
    for (g->learnDicStartPoint = LEARNDICHEADERSIZE;
	 g->learnDicStartPoint < g->learnDicLen;
	 g->learnDicStartPoint++) {
      if ((g->learnDicP[g->learnDicStartPoint] == linefeedChr) && 
	  (g->learnDicP[g->learnDicStartPoint + 1] != linefeedChr)) {
	g->learnDicStartPoint++; 
	return(g->learnDicH);
      }
    }
  }
  //  WinDrawChars(g->learnDicP + g->learnDicStartPoint, 30, 0, 120);
  return(g->learnDicH);
}


// This function doesn't close memoDB
Err ManaeReleaseLearnCandRec(GlobalPtr g)
{
  Err ret;

#ifdef DEBUG
  ErrorPrint("ManaeReleaseLearnCandRec", 0, 0);
#endif

  if (g->learnDicH) {
    MemHandleUnlock(g->learnDicH);
    ret = DmReleaseRecord(g->manaeDB, g->learnDicI, true);
    g->learnDicI = 0;
    g->learnDicH = NULL;
    g->learnDicP = NULL;
  } else {
    return(0xff); // error
  }
  return(ret);
}

// This function doesn't close memoDB
Err ManaeReleaseOnlyLearnCandRec(GlobalPtr g)
{
  Err ret;

#ifdef DEBUG
  ErrorPrint("ManaeReleaseLearnCandRec", 0, 0);
#endif

  if (g->learnDicH) {
    //    MemHandleUnlock(g->learnDicH);
    ret = DmReleaseRecord(g->manaeDB, g->learnDicI, true);
    g->learnDicI = 0;
    g->learnDicH = NULL;
    g->learnDicP = NULL;
  } else {
    return(0xff); // error
  }
  return(ret);
}

#endif

DmOpenRef OpenKanjiDB(GlobalPtr g)
{
  g->kanjiDB = 
    DmOpenDatabaseByTypeCreator('DICt', 'JPOs', dmModeReadOnly);
  return(g->kanjiDB);
}


Err CloseKanjiDB(GlobalPtr g)
{
  Err ret;

  ret = 0;
  if (g->kanjiDB != NULL) {
    ret = DmCloseDatabase(g->kanjiDB);
    g->kanjiDB = NULL;
    return(ret);
  }
  return(0);
}

VoidHand ManaeGetCandRec(GlobalPtr g)
{
  Int candID;

  g->dicH = NULL;

  OpenKanjiDB(g);

  g->candP = NULL;
  // check the first char.
  if (g->kanaP[0] != (Char)0x82) {
    return(NULL);
  }
  if ((g->kanaP[1] <(Char)0x9f) || (g->kanaP[1] > (Char)0xed)) {
    return(NULL);
  }
  
  // Get Resource Handle	
  // Calc ID
  candID = g->kanaP[1] - (Char)0x9f;
  g->dicH = DmGet1Resource('DICt', candID);
  if (g->dicH == NULL) {
    return NULL;
  }
  //  MemHandleSetOwner(g->dicH, 0);
  // Get the 1st one char's entry resource
  g->candP = MemHandleLock(g->dicH);
  g->candRecLen = MemHandleSize(g->dicH);
  return(g->dicH);
}

Err ManaeReleaseCandRec(GlobalPtr g)
{
  if (g->dicH) {
    MemHandleUnlock(g->dicH);
    DmReleaseResource(g->dicH);
  }
  g->dicH = NULL;
  return(CloseKanjiDB(g));
}

Err ManaeReleaseOnlyCandRec(GlobalPtr g)
{
  if (g->dicH) {
    //    MemHandleUnlock(g->dicH);
    DmReleaseResource(g->dicH);
  }
  g->dicH = NULL;
  return(CloseKanjiDB(g));
}

