/* 
   manae --- skimple kana MANA Exchanger
   prefsRec.c --- handling preferences record.
   Copyright 1998-2000 IWAMA Naozumi
   This file is written in SJIS.
   ̃t@C SJIS ŋLqĂ܂B
*/

#include <stdio.h>
#include <System/SysAll.h>
#include <System/Graffiti.h>
#include <UI/UIAll.h>
#include <System/FeatureMgr.h>

#include "manae.h"
#include "id.h"

/* Preferences
              NON-SKK (1: non-skk mode)
              | Thumb Type (1: Thumb Type mode)
              | |    gui mode
              | |    |
   0000 0000 0000 0000
      |    |
      |    kanjiMode
      mode
*/

#define MODESHIFT	12
#define MODEMASK	0x0000f000
#define KANJIMODESHIFT	8
#define KANJIMODEMASK	0x00000f00
#define NONSKKMODESHIFT	6
#define NONSKKMODEMASK	0x00000040
#define THUMBTYPEMODESHIFT	4
#define THUMBTYPEMODEMASK	0x00000010
#define GUIMODESHIFT	0
#define GUIMODEMASK	0x0000000f

Byte PreferencesGetMode(DWord ftrVal)
{
  return((Char)((ftrVal & MODEMASK) >> MODESHIFT));
}

DWord PreferencesSetMode(Char mode, DWordPtr ftrValP)
{
  return((*ftrValP = (*ftrValP & ~MODEMASK) | ((mode << MODESHIFT) & MODEMASK)));
}

Byte PreferencesGetKanjiMode(DWord ftrVal)
{
  return((Char)((KANJIMODEMASK & ftrVal) >> KANJIMODESHIFT));
}

DWord PreferencesSetKanjiMode(Char mode, DWordPtr ftrValP)
{
  return((*ftrValP = (*ftrValP & ~KANJIMODEMASK) |
	  ((mode << KANJIMODESHIFT) & KANJIMODEMASK)));
}

Boolean PreferencesGetNonSkkMode(DWord ftrVal)
{
  return((Boolean)((NONSKKMODEMASK & ftrVal) >> NONSKKMODESHIFT));
}

DWord PreferencesSetNonSkkMode(Boolean nonSkk, DWordPtr ftrValP)
{
  return((*ftrValP = (*ftrValP & ~NONSKKMODEMASK) |
	  ((nonSkk << NONSKKMODESHIFT) & NONSKKMODEMASK)));
}

Boolean PreferencesGetThumbTypeMode(DWord ftrVal)
{
  return((Boolean)((THUMBTYPEMODEMASK & ftrVal) >> THUMBTYPEMODESHIFT));
}

DWord PreferencesSetThumbTypeMode(Boolean thumbType, DWordPtr ftrValP)
{
  return((*ftrValP = (*ftrValP & ~THUMBTYPEMODEMASK) |
	  ((thumbType << THUMBTYPEMODESHIFT) & THUMBTYPEMODEMASK)));
}

Byte PreferencesGetGuiMode(DWord ftrVal)
{
  return((Byte)((GUIMODEMASK & ftrVal) >> GUIMODESHIFT));
}

DWord PreferencesSetGuiMode(Byte guiMode, DWordPtr ftrValP)
{
  return((*ftrValP = (*ftrValP & ~GUIMODEMASK) |
	  ((guiMode << GUIMODESHIFT) & GUIMODEMASK)));
}

Boolean PreferencesSave(VoidPtr prefsP)
{
  DWord mmMode;
  Boolean result;
#ifdef DEBUG  
  Char str[30];
#endif
  result = true;
  
  if (FtrGet(CREATOR, FEATUREMANAEMORI, &mmMode) != 0) { // if there is a error.
    mmMode = 4;
    FtrSet(CREATOR, FEATUREMANAEMORI, mmMode);
    result = false;
  }
  DmWrite(prefsP, 0, &mmMode, sizeof(DWord));

#ifdef DEBUG  
  StrPrintF(str, "%lx", *(DWordPtr)prefsP);
  WinDrawChars(str, StrLen(str), 0, 20);
  StrPrintF(str, "%lx", mmMode);
  WinDrawChars(str, StrLen(str), 100, 20);
#endif

  if (FtrGet(CREATOR, FEATURECANDSPOPUP, &mmMode) != 0) {
    mmMode = 4;
    FtrSet(CREATOR, FEATURECANDSPOPUP, mmMode);
    result = false;
  }
  DmWrite(prefsP, sizeof(DWord), &mmMode, sizeof(DWord));

  return(result);
}

Boolean PreferencesLoad(VoidPtr prefsP)
{
  Boolean result;
#ifdef DEBUG  
  Char str[30];
#endif

  result = true;
  if (FtrSet(CREATOR, FEATUREMANAEMORI, *(DWordPtr)prefsP) != 0) {
    //    FrmCustomAlert(Alert, "manae", "prefsRec.c", "can't set a feature.");
    result = false;
  }

#ifdef DEBUG  
  StrPrintF(str, "%lx", *(DWordPtr)prefsP);
  WinDrawChars(str, StrLen(str), 0, 40);
#endif

  if (FtrSet(CREATOR, FEATURECANDSPOPUP, *(DWordPtr)(prefsP + sizeof(DWord))) != 0) {
    //    FrmCustomAlert(Alert, "manae", "prefsRec.c", "can't set a feature.");
    result = false;
  }

#ifdef DEBUG  
  StrPrintF(str, "%lx", *(DWordPtr)(prefsP + sizeof(DWord)));
  WinDrawChars(str, StrLen(str), 0, 60);
#endif

  return(result);
}
